// Modules to control application life and create native browser window
const { app, BrowserWindow } = require('electron')
const path = require('path')
const { MainProcess } = require('./src/sevice/index')
const { file, shell } = require('./src/command/index')
const ProcessActivity = require('./src/sevice/process')

class Main {
  constructor() {
    this.ready()
  }
  init(mainWindow) {
    new MainProcess(mainWindow)
    new ProcessActivity().init()
  }
  ready() {
    app.whenReady().then(() => {
      this.createWindow()

      app.on('activate', function () {
        if (BrowserWindow.getAllWindows().length === 0) this.createWindow()
      })
    })
    app.on('window-all-closed', function () {
      // if (process.platform !== 'darwin') 
      app.quit()
    })
  }
  createWindow() {
    const mainWindow = new BrowserWindow({
      width: 1024,
      height: 768,
      webPreferences: {
        preload: path.join(__dirname, 'preload.js'),
        sandbox: false,
        // contextIsolation: true
      }
    })

    // mainWindow.loadFile('index.html')
    mainWindow.loadURL('http://localhost:45625/#/')
    mainWindow.webContents.openDevTools()
    this.init(mainWindow)
  }
}


new Main()