const { Worker, isMainThread } = require('node:worker_threads');
const shelljs = require('shelljs')
const cluster = require('cluster')
const path = require('path')

// 执行进程命令，需使用nodejs启动，否则会不可控
class ProcessActivity {
  init() {
    const shellPath = path.join(process.cwd(), './src/command/shell.js')
    this.processArray = []
    this.index = null
    this.pids = []
    this.batchCommand(shellPath)
    setTimeout(() => {
      this.processClose()
    }, 0);
  }

  batchCommand(shellPath) {
    cluster.setupPrimary({
      exec: shellPath,
      args: ['development'],
      silent: true
    });
    const work = cluster.fork();
    this.processArray.push(work)
  }

  // 进程启动

  // 进程关闭
  processClose() {
    this.processArray.forEach(work => {
      work.on('disconnect', () => this.disconnect(work))
      work.on('exit', () => this.exit(work))
      // 进程重启
    })
  }

  exit(work) {
    this.kill(work.pid)
  }

  disconnect(work) {
    this.kill(work.pid)
  }

  kill(pid) {
    const t = setTimeout(() => {
      process.kill(pid)
      process.exit(0)
      clearTimeout(t)
    }, 2000);
  }

  // 进程重启
}

module.exports = ProcessActivity